<template>
  <a-layout>
    <a-layout-header>
      <span class="title">Tài khoản Khách hàng</span>
      <span style="flex: 1" />
      <div class="settings">
        <a-button
          @click="handleCreatePatient"
          v-if="!isConsultant"
          type="primary"
          icon="plus"
          style="margin-right: 8px;"
        >
          Thêm Khách hàng
        </a-button>
      </div>
    </a-layout-header>
    <a-layout-content>
      <search />
      <div style="height: 16px" />
      <a-card :bordered="false" :bodyStyle="{ padding: '24px 16px 8px 16px' }">
        <a-table
          :columns="columns"
          :row-key="record => record.id"
          :data-source="accounts"
          :pagination="pagination"
          :loading="loading"
          :scroll="{x:tableX}"
          @change="onTableChange"
        >
          <template slot="userIdentity" slot-scope="userIdentity">
            <span>
              {{ userIdentity.gender | NamePrefix }}{{ userIdentity.name }}
            </span>
            <br>
            <span class="sub-text">{{ userIdentity.username }}</span>
          </template>
          <template slot="supporter" slot-scope="user">
            <span v-if="user.supporter">
              {{ user.supporter.gender | NamePrefix }}{{ user.supporter.name }}
              <a @click="showPatientSupporterDialog(user)"><a-icon type="edit" /> Sửa</a>
            </span>
            <span v-else>
              <a @click="showPatientSupporterDialog(user)"><a-icon type="user-add" /> Thêm</a>
            </span>
          </template>
          <template slot="consultant" slot-scope="user">
            <span v-if="user.consultant">
              {{ user.consultant.gender | NamePrefix }}{{ user.consultant.name }}
              <a v-if="isAdmin" @click="showPatientConsultantDialog(user)"><a-icon type="edit" /> Sửa</a>
            </span>
            <span v-else>
              <a v-if="isAdmin" @click="showPatientConsultantDialog(user)"><a-icon type="user-add" /> Thêm</a>
              <a v-else>Chưa được chỉ định</a>
            </span>
          </template>
          <template slot="info" slot-scope="info">
            <span>
              <a-icon type="mail" />
              {{ info.email }}
            </span>
            <br>
            <span>
              <a-icon type="phone" />
              {{ info.telecom }}
            </span>
          </template>
          <template slot="status" slot-scope="status">
            <a-tag :color="status === 'ACTIVE' ? '#1890ff' : '#F5222D'">
              {{ status | UserStatus }}
            </a-tag>
          </template>
          <template
            slot="lastUpdatedDate"
            slot-scope="lastUpdatedDate"
          >
            {{ lastUpdatedDate | DateFormat('DD/MM/YYYY hh:mm') }}
          </template>
          <template
            slot="createdDate"
            slot-scope="createdDate"
          >
            {{ createdDate | DateFormat('DD/MM/YYYY hh:mm') }}
          </template>
          <template slot="action" slot-scope="user">
            <a-dropdown :trigger="['click']">
              <a @click="e => e.preventDefault()" class="ant-dropdown-link">
                Công cụ
                <a-icon type="down" />
              </a>
              <a-menu slot="overlay">
                <a-menu-item key="2" v-if="!isConsultant">
                  <a @click="e => handleUpdatePatient(e, user)">
                    <a-icon type="edit" />
                    <span class="menu-item">Chỉnh sửa thông tin tài khoản</span>
                  </a>
                </a-menu-item>
                <a-menu-item key="0">
                  <a @click="e => handleOpenPatientPortal(e, user, 'view')">
                    <a-icon type="contacts" />
                    <span class="menu-item">Xem HSSK</span>
                  </a>
                </a-menu-item>
                <a-menu-item key="5" v-if="!isConsultant">
                  <a @click="e => handleOpenPatientPortal(e, user, 'edit')">
                    <a-icon type="form" />
                    <span class="menu-item">Chỉnh sửa HSSK</span>
                  </a>
                </a-menu-item>
                <a-menu-item key="4">
                  <a @click="e => handleGenInstantCode(e, user)">
                    <a-icon type="barcode" />
                    <span class="menu-item">Tạo mã truy cập tạm thời</span>
                  </a>
                </a-menu-item>

                <a-menu-item key="3" v-if="!isConsultant">
                  <a-popconfirm
                    @confirm="handleUpdatePatientStt(user)"
                    :title="user.status === 'ACTIVE' ? 'Bạn thực sự muốn vô hiệu tài khoản này ?' : 'Bạn thực sự muốn kích hoạt tài khoản này ?'"
                    ok-text="Có"
                    cancel-text="Không"
                  >
                    <a>
                      <a-icon :type="user.status === 'ACTIVE' ? 'exclamation' : 'check'" />
                      <span class="menu-item">
                        {{ user.status === 'ACTIVE' ? 'Vô hiệu tài khoản' : 'Tái kích hoạt tài khoản' }}
                      </span>
                    </a>
                  </a-popconfirm>
                </a-menu-item>
              </a-menu>
            </a-dropdown>
          </template>
        </a-table>
        <a-modal :footer="null" v-model="visible" @ok="handleHideInstantCodeModal" title="Mã truy cập">
          <div class="instant-code">
            <span>{{ instantCode }}</span>
          </div>
        </a-modal>
        <change-supporter-dialog
          ref="changeSupporterDialog"
          :submit="handleUpdatePatientSupporter"
        />
        <change-consultant-dialog
          ref="changeConsultantDialog"
          :submit="handleUpdatePatientConsultant"
        />
      </a-card>
    </a-layout-content>
  </a-layout>
</template>
<script>
import { mapGetters, mapActions } from 'vuex'
import { mixin, mixinDevice } from '@/utils/mixin'
import { ehrApi } from '@/api'
import { Search, ChangeSupporterDialog, ChangeConsultantDialog } from './components'

export default {
  components: {
    Search,
    ChangeSupporterDialog,
    ChangeConsultantDialog
  },
  mixins: [mixin, mixinDevice],
  data () {
    return {
      form: this.$form.createForm(this),
      data: [],
      visible: false,
      instantCode: ''
    }
  },
  computed: {
    ...mapGetters('account', ['accounts', 'loading', 'page', 'total']),
    ...mapGetters('auth', ['userId', 'role', 'isManager', 'isAdmin', 'isConsultant']),
    tableX () {
      return this.isManager ? 1870 : 1270
    },
    columns () {
      return [
        {
          title: 'Định danh',
          key: 'name',
          sorter: true,
          width: 300,
          sortDirections: ['descend', 'ascend'],
          scopedSlots: { customRender: 'userIdentity' }
        },
        {
          title: 'Thông tin liên lạc',
          key: 'userInfo',
          width: 300,
          scopedSlots: { customRender: 'info' }
        },
        {
          title: 'Trạng thái',
          dataIndex: 'status',
          key: 'status',
          width: 150,
          scopedSlots: { customRender: 'status' }
        },
        (this.isManager && {
          title: 'Nhân viên CSKH',
          key: 'supporter',
          width: 300,
          scopedSlots: { customRender: 'supporter' }
        }),
        (this.isManager && {
          title: 'Tư vấn viên',
          key: 'consultant',
          width: 300,
          scopedSlots: { customRender: 'consultant' }
        }),
        {
          title: 'Ngày tạo',
          dataIndex: 'createdDate',
          key: 'createdDate',
          sorter: true,
          width: 200,
          sortDirections: ['descend', 'ascend'],
          scopedSlots: { customRender: 'createdDate' }
        },
        {
          title: 'Chỉnh sửa gần đây',
          dataIndex: 'lastUpdatedDate',
          key: 'lastUpdatedDate',
          sorter: true,
          width: 200,
          sortDirections: ['descend', 'ascend'],
          defaultSortOrder: 'descend',
          scopedSlots: { customRender: 'lastUpdatedDate' }
        },
        {
          title: '',
          dataIndex: '',
          key: 'action',
          width: 120,
          fixed: 'right',
          scopedSlots: { customRender: 'action' }
        }
      ]
    },
    pagination () {
      return {
        current: this.page,
        pageSize: 10,
        total: this.total
      }
    },
    currentPage () {
      const { page } = this.$route.query
      const pageInt = parseInt(page)
      const currentPage = {
        page: 1,
        ...(pageInt > 1 && { page })
      }
      return currentPage
    },
    sorter () {
      const { sortField, sortOrder } = this.$route.query
      return {
        order: 'lastUpdatedDate DESC',
        ...(sortField && sortOrder && { order: `${sortField} ${sortOrder}` })
      }
    },
    getSortOrder (field) {
      const { sortField, sortOrder } = this.$route.query
      if (field === sortField) {
        if (sortOrder === 'ASC') { return 'ascend' }
        if (sortOrder === 'DESC') { return 'descend' }
      }
      return null
    },
    filter () {
      const { name, email, status, supporterId, consultantId } = this.$route.query
      const filter = {
        where: {
          ...(name && { name: { ilike: encodeURI(`%${name}%`) } }),
          ...(email && { email: { ilike: encodeURI(`%${email}%`) } }),
          ...(status && { status }),
          ...(supporterId && { supporterId }),
          ...(consultantId && { consultantId })
        },
        ...this.sorter,
        include: ['supporter', 'consultant'],
        limit: 10
      }
      return filter
    }
  },
  watch: {
    '$route.query': {
      handler () {
        this.fetchAccounts()
      },
      immediate: true
    }
  },
  async created () {
    await this.fetchAccounts()
  },
  methods: {
    ...mapActions('account', ['getAccounts', 'updateAccount']),
    handleCreatePatient () {
      this.$router.push({ name: 'create-account' })
    },
    showPatientSupporterDialog (patient) {
      this.$refs.changeSupporterDialog.show(patient)
    },
    showPatientConsultantDialog (patient) {
      this.$refs.changeConsultantDialog.show(patient)
    },
    async handleUpdatePatientConsultant ({ id, consultantId }) {
      try {
        const payload = {
          id,
          consultantId
        }
        const usr = await ehrApi.supporter.updatePatient(payload)
        const consultant = await ehrApi.user.getAccount(consultantId)
        await this.updateAccount({ ...usr, consultant })
      } catch (error) {
        this.notiError(error)
      }
    },
    async handleUpdatePatientSupporter ({ id, supporterId }) {
      try {
        const payload = {
          id,
          supporterId
        }
        const usr = await ehrApi.supporter.updatePatient(payload)
        const spt = await ehrApi.user.getAccount(supporterId)
        await this.updateAccount({ ...usr, supporter: spt })
      } catch (error) {
        this.notiError(error)
      }
    },
    handleUpdatePatient (e, data) {
      e.preventDefault()
      this.$router.push({ name: 'update-account', params: { id: data.id } })
    },
    handleHideInstantCodeModal () {
      this.visible = false
      this.instantCode = ''
    },
    handleShowInstantCodeModal () {
      this.visible = true
    },
    async handleGenInstantCode (e, data) {
      try {
        const { fhirId } = data
        const payload = {
          fhirId,
          supporterId: this.userId
        }
        const { code } = await ehrApi.supporter.getInstantCode(payload)
        this.instantCode = code
        this.handleShowInstantCodeModal()
      } catch (error) {
        this.notiError(error)
      }
    },
    async handleUpdatePatientStt (data) {
      try {
        const { id, status } = data
        const payload = {
          id,
          status: status === 'ACTIVE' ? 'INACTIVE' : 'ACTIVE'
        }
        const usr = await ehrApi.supporter.updatePatientStt(payload)
        await this.updateAccount(usr)
      } catch (error) {
        this.notiError(error)
      }
    },
    async handleOpenPatientPortal (e, { fhirId }, mode = 'update') {
      try {
        e.preventDefault()
        const { code } = await ehrApi.supporter.getInstantCode({
          fhirId,
          supporterId: this.userId
        })
        const redirectUrl = process.env.NUXT_ENV_PATIENT_PORTAL_URL
        window.open(`${redirectUrl}?code=${code}&mode=${mode}`, '_blank')
      } catch (error) {
        this.notiError(error)
      }
    },
    fetchAccounts () {
      const payload = {
        filter: this.filter,
        ...this.currentPage,
        role: this.role
      }
      return this.getAccounts(payload)
    },
    onTableChange (pagination, filters, sorter) {
      const queryParams = {
        page: pagination.current
      }
      const { columnKey: sortField, order: sortOrder } = sorter
      if (sortField && sortOrder) {
        queryParams.sortField = sortField
        queryParams.sortOrder = sortOrder === 'ascend' ? 'ASC' : 'DESC'
      }
      const { path } = this.$route
      this.$router.push({ path, query: { ...this.$route.query, ...queryParams } })
    },
    reload () {
      this.fetchAccounts()
    },
    notiError (err) {
      this.$notification.error({
        message: 'Lỗi hệ thống',
        description: 'Có lỗi xảy ra' || err,
        duration: 4
      })
    }
  }
}
</script>
<style lang="scss" scoped>
.menu-item {
  display: inline-block;
  padding-left: 8px;
}
.instant-code {
  display: flex;
  justify-content: center;
  align-items: center;
  font-size: 28px;
}
.sub-text {
  color: rgba(0, 0, 0, 0.4);
}
</style>
